/*********************************************************************/
/*                  pC++/Sage++  Copyright (C) 1993                  */
/*  Indiana University  University of Oregon  University of Rennes   */
/*********************************************************************/
     
#include "compatible.h"
#ifdef SYS5
#include <string.h>
#else
#include <strings.h>
#endif

#include "db.h"

/* this is added  */
/***
#include "SiEList.h"
#include "SiFuns.h"
***/
int debug = 0;
int show_deps = 0;  /* these two definitions are needed for the library */


/*  */

static FILE  *fptm,*fptm1,*fptm2;

static FILE *fd;

#define FOLLOW_BIF_POINTER_TO_ID(VAR) \
    (bf_ptr->entry.Template.VAR? bf_ptr-> entry.Template.VAR->id: -1)

#define FOLLOW_LL_POINTER_TO_ID(VAR) \
    (ll_ptr-> entry.Template.VAR? ll_ptr-> entry.Template.VAR->id: -1)

#define FOLLOW_SYMB_POINTER_1_TO_ID(VAR) \
    (sy_ptr->VAR? sy_ptr->VAR->id: -1)

#define FOLLOW_SYMB_POINTER_2_TO_ID(VAR) \
    (sy_ptr->entry.VAR? sy_ptr->entry.VAR->id: -1)

#define FOLLOW_TYPE_POINTER_TO_ID(VAR) \
    (ty_ptr->entry.VAR? ty_ptr->entry.VAR->id: -1)

#define FOLLOW_DEP_TO_ID(VAR) \
    (dep->VAR? dep->VAR->id: -1)

char   *tag[610];
int    depden_llnd[500][2],depden_llnd_sum;

/*------------------------------------------------------*
 *		    is_blank     			*
 *   checks if string is all blanks                     *
 *           (BW)                                       *
 *------------------------------------------------------*/
static int 
is_blank (buf)
           char *buf;
{
       int i;
       char ch;
       for (i=0; i<(int)strlen(buf); i++){
           if (buf[i] != ' ') return 0;
       }
       return 1;

}

/*------------------------------------------------------*
 *		    replace_1     			*
 *   replaces all occurrences of -1 in the string       *
 *    by --  (BW)                                       *
 *------------------------------------------------------*/
static void 
replace_1 (buf)
           char *buf;
{
       char ch;
       int flag;

       ch = *buf;
       flag = 0;
       while (ch != '\0') {
             if (ch == '-') flag ++;
             if (ch == '1' && flag == 1){
                    flag = 2;
                    }
             if (ch == ' ' && flag > 0) flag = 0;
             if (flag >= 2) *buf = '-';
             else *buf = ch;
             buf++;
             ch = *buf;
      }
}

/*------------------------------------------------------*
 *		    my_fprintf_XX     			*
 *   reformat fprintf output to replace -1 by --        *
 *                   (BW)                               *
 *------------------------------------------------------*/
static void 
my_fprintf_0 (fd, val_0, val_1, val_2, val_3, val_4, val_5, val_6, val_7, val_8,
                  val_9, val_10, val_11, val_12, val_13, val_14, val_15, val_16, val_17, val_18)
           FILE *fd;
           char *val_0, *val_18;
           int val_1, val_2, val_3, val_4, val_5, val_6, val_7, val_8, val_9,
               val_10, val_11, val_12, val_13, val_14, val_15, val_16, val_17;
{
       char buf[256];
       sprintf(buf,val_0, val_1, val_2, val_3, val_4, val_5, val_6, val_7, val_8,
                  val_9, val_10, val_11, val_12, val_13, val_14, val_15, val_16, val_17, val_18);
       replace_1(buf);
       fprintf(fd, "%s", buf);
}

static void 
my_fprintf_1 (fd, val_0, val_1, val_2, val_3)
           FILE *fd;
           char *val_0;
           int val_1, val_2, val_3;
{
       char buf[256];
       sprintf(buf,val_0, val_1, val_2, val_3);
       replace_1(buf);
       fprintf(fd, "%s", buf);
}

static void 
my_fprintf_2 (fd, val_0, val_1, val_2, val_3, val_4, val_5, val_6, val_7)
           FILE *fd;
           char *val_0, *val_7;
           int val_1, val_2, val_3, val_4, val_5, val_6;
{
       char buf[256];
       sprintf(buf,val_0, val_1, val_2, val_3, val_4, val_5, val_6, val_7);
       replace_1(buf);
       fprintf(fd, "%s", buf);
}

static void 
my_fprintf_3 (fd, val_0, val_1, val_2, val_3, val_4)
           FILE *fd;
           char *val_0;
           int val_1, val_2, val_3, val_4;
{
       char buf[256];
       sprintf(buf,val_0, val_1, val_2, val_3, val_4);
       replace_1(buf);
       fprintf(fd, "%s", buf);
}

static void 
my_fprintf_4 (fd, val_0, val_1)
           FILE *fd;
           char *val_0;
           int val_1;
{
       char buf[256];
       sprintf(buf,val_0, val_1);
       replace_1(buf);
       fprintf(fd, "%s", buf);
}

static void 
my_fprintf_5 (fd, val_0, val_1, val_2)
           FILE *fd;
           char *val_0;
           int val_1, val_2;
{
       char buf[256];
       sprintf(buf,val_0, val_1, val_2);
       replace_1(buf);
       fprintf(fd, "%s", buf);
}

static void 
my_fprintf_6 (fd, val_0, val_1, val_2, val_3, val_4, val_5)
           FILE *fd;
           char *val_0;
           int val_1, val_2, val_4, val_5;
           long val_3;
{
       char buf[256];
       sprintf(buf,val_0, val_1, val_2, val_3, val_4, val_5);
       replace_1(buf);
       fprintf(fd, "%s", buf);
}


/*------------------------------------------------------*
 *		    print_ls_flg     			*
 *   print out whixh bits are set in num, used for      *
 *   long_short flag (BW)                               *
 *------------------------------------------------------*/
static void 
print_ls_flg (num)
           unsigned long num;
{
       int i;
       fprintf(fd, " ls_flg(bits set)= ");
       for(i=0; i<32; i++) {
           if (num & (1<<i))
                fprintf(fd, "%2d ", i);
       }
       fprintf(fd, "\n");
}


/*------------------------------------------------------*
 *		    print_accs_flg     			*
 *   print out whixh bits are set in num, used for      *
 *   accs_flg flag (BW)                               *
 *------------------------------------------------------*/
static void 
print_accs_flg (num)
           unsigned long num;
{
       int i;
       fprintf(fd, " accs_flg(bits set)= ");
       for(i=0; i<32; i++) {
           if (num & (1<<i))
                fprintf(fd, "%2d ", i);
       }
}

/*------------------------------------------------------*
 *		    print_decl_specs     		*
 *   print out which bits are set in num, used for      *
 *   decl_specs flag  in bif nodes (BW)                 *
 *------------------------------------------------------*/
static void 
print_decl_specs (num)
           unsigned long num;
{
       int i;
       fprintf(fd, "         decl_specs(bits set)= ");
       for(i=0; i<32; i++) {
           if (num & (1<<i))
                fprintf(fd, "%2d ", i);
       }
      fprintf(fd, "\n");
}


/*------------------------------------------------------*
 *		      write_sizes			*
 *------------------------------------------------------*/
static void
write_sizes(f)
	PTR_FILE f;
{
	int	n1, n2, n3, n4, n5, n6, n7, n8, n9, n10;

	n1 = f->num_blobs;
	n2 = f->num_bfnds;
	n3 = f->num_llnds;
	n4 = f->num_symbs;
	n5 = f->num_types;
	n6 = f->num_label;
	n7 = f->global_bfnd->id;
	n8 = f->num_dep;
	n9 = f->num_cmnt;
	n10= f->num_files;

        fprintf(fd,"\n #blob  #bfnd  #llnd  #symb      #type  #labl  GblBf #deps  #cmnt  #file\n");
	fprintf(fd,"-------------------------------------------------------------------------\n");
	fprintf(fd,"%5d  %5d  %5d  %5d	%5d %5d  %5d  %5d  %5d  %5d\n\n",
	       n1, n2, n3, n4, n5, n6, n7, n8, n9, n10);
}
/*------------------------------------------------------*
 *                 write_blob_list1                          *
 *                                                           *
 *      dump the blob list with the given head  number        *
 *------------------------------------------------------*/
static void
write_blob_list1(head)
        PTR_BLOB head;
{
        register PTR_BLOB bl_ptr;
        int               i1=0;
        for (bl_ptr = head; bl_ptr; bl_ptr = bl_ptr->next)
            i1++;
        putw(i1,fptm);
}


/*------------------------------------------------------*
 *		   write_blob_list			*
 *							*
 *	dump the blob list with the given head		*
 *------------------------------------------------------*/
static void
write_blob_list(head)
	PTR_BLOB head;
{
	register PTR_BLOB bl_ptr;

	fprintf(fd," %10s", " ");
	for (bl_ptr = head; bl_ptr; bl_ptr = bl_ptr->next)
            { 
		fprintf(fd,"%5d-B ", bl_ptr->ref->id);
                putw(bl_ptr->ref->id,fptm);
            }
	fprintf(fd,"   --\n");
}


/*------------------------------------------------------*
 *		    write_bif_node			*
 *							*
 *	    routines to print one bif node		*
 *------------------------------------------------------*/
static void
write_bif_node(bf_ptr)
	PTR_BFND bf_ptr;
{
	int n1, n2, n3, n4, n5, n6, n7, n8, n9, n10, n11, n12, n13, n14, n15, n16, n17;

	n1 = bf_ptr->id;
	n2 = bf_ptr->variant;
	n3 = bf_ptr->control_parent ? bf_ptr->control_parent->id : -1;
	n4 = FOLLOW_BIF_POINTER_TO_ID(bf_ptr1);
	n5 = FOLLOW_BIF_POINTER_TO_ID(cmnt_ptr);
	n6 = FOLLOW_BIF_POINTER_TO_ID(symbol);
	n7 = FOLLOW_BIF_POINTER_TO_ID(ll_ptr1);
	n8 = FOLLOW_BIF_POINTER_TO_ID(ll_ptr2);
	n9 = FOLLOW_BIF_POINTER_TO_ID(ll_ptr3);
	n10 = FOLLOW_BIF_POINTER_TO_ID(dep_ptr1);
	n11 = FOLLOW_BIF_POINTER_TO_ID(dep_ptr2);
	n12 = bf_ptr->label? bf_ptr->label->id: -1;
	n13 = FOLLOW_BIF_POINTER_TO_ID(lbl_ptr);
	n14 = bf_ptr->g_line;
	n15 = bf_ptr->l_line;
	n16 = bf_ptr->filename->id;
	n17 = (bf_ptr->thread)? bf_ptr->thread->id: -1;

	my_fprintf_0(fd,"%3d-B %3d %3d-B %3d %3d-C %3d-S %4d-E %4d-E %4d-E %4d %4d %4d-L %3d %3d %4d %5d-F %5d-B %12s\n",
	      n1, n2, n3, n4, n5, n6, n7, n8, n9, n10, n11, n12, n13, n14, n15, n16, n17,
	      tag[bf_ptr->variant]);
        putw(n1,fptm);
        putw(n2,fptm);
        putw(n3,fptm);
        putw(n14,fptm);
        putw(n15,fptm);

        write_blob_list1(bf_ptr->entry.Template.bl_ptr1);   /*  remember
                                              bl_ptr1  and  bl_ptr2  number
 */
        write_blob_list1(bf_ptr->entry.Template.bl_ptr2);

	write_blob_list(bf_ptr->entry.Template.bl_ptr1);
	write_blob_list(bf_ptr->entry.Template.bl_ptr2);
        print_decl_specs(bf_ptr->decl_specs);
}



/*------------------------------------------------------*
 *		  write_bif_nodes			*
 *							*
 *	     routines to print bif nodes		*
 *------------------------------------------------------*/
static void
write_bif_nodes(f)
	PTR_FILE f;
{
	register PTR_BFND bf_ptr;
 fprintf(fd, "***BIF NODES***\n\n");
 fprintf(fd,"  id  var  cp   bp1  cmnt  sym    lp1    lp2    lp3    dp1  dp2   lab  lbl glin llin  file  thread\n");
	for (bf_ptr = f->head_bfnd; bf_ptr; bf_ptr = bf_ptr->thread)
		write_bif_node(bf_ptr);
}


/*------------------------------------------------------*
 *		     write_ll_node			*
 *							*
 *	       print out one low level node		*
 *------------------------------------------------------*/
static void 
write_ll_node(ll_ptr)
	PTR_LLND ll_ptr;
{
	int	n1, n2, n3;

	n1 = ll_ptr->id;
	n2 = ll_ptr->variant;
	n3 = ll_ptr->type ? ll_ptr->type->id : -1;
	my_fprintf_1(fd,"%5d-E %5d %5d-T ", n1, n2, n3);
	switch (ll_ptr->variant) {
	    case (INT_VAL):
		fprintf(fd,"%23d", ll_ptr->entry.ival);
		break;
	    case (DOUBLE_VAL):
	    case (FLOAT_VAL):
		fprintf(fd,"%23s", ll_ptr->entry.string_val);
		break;
	    case (BOOL_VAL):
		fprintf(fd,"%23s", ll_ptr->entry.bval ? ".T" : ".F");
		break;
	    case (CHAR_VAL):
		fprintf(fd,"%22c%c", '.', ll_ptr->entry.cval);
		break;
	    case (STMT_STR):
	    case (KEYWORD_VAL):
	    case (STRING_VAL):
		fprintf(fd,"  \"%s\"  ", ll_ptr->entry.string_val);
		break;
	    case (RANGE_OP):
	    case (UPPER_OP):
	    case (LOWER_OP):
		n1 = ll_ptr->entry.array_op.symbol ?
			ll_ptr->entry.array_op.symbol->id :
			-1;
		n2 = ll_ptr->entry.array_op.dim;
		my_fprintf_4(fd,"%11d-S", n1);
		fprintf(fd," %5d", n2);
   
		break;
	    case (LABEL_REF):
/*		n1 = FOLLOW_LL_POINTER_TO_ID(symbol);
 */		n1 = ll_ptr->entry.label_list.lab_ptr->id;
		fprintf(fd,"                %5d-L %1s", n1, " ");
		break;
	    case  (ARITH_ASSGN_OP): /* New added for VPC++ */
		n1 = (int) ll_ptr->entry.Template.symbol;
		n2 = FOLLOW_LL_POINTER_TO_ID(ll_ptr1);
		n3 = FOLLOW_LL_POINTER_TO_ID(ll_ptr2);
		my_fprintf_1(fd,"%5d-S %5d-E %5d-E", n1, n2, n3);	
		break;
	   default:
		n1 = FOLLOW_LL_POINTER_TO_ID(symbol);
		n2 = FOLLOW_LL_POINTER_TO_ID(ll_ptr1);
		n3 = FOLLOW_LL_POINTER_TO_ID(ll_ptr2);
		my_fprintf_1(fd,"%5d-S %5d-E %5d-E", n1, n2, n3);	
	}
	fprintf(fd,"%30s\n", tag[ll_ptr->variant]);
}


/*------------------------------------------------------*
 *		  write_ll_nodes			*
 *							*
 *		dump low level nodes			*
 *------------------------------------------------------*/
static void
write_ll_nodes(f)
	PTR_FILE f;
{
	register PTR_LLND ll_ptr;
        fprintf(fd,"***L0W-LEVEL NODES***\n\n");
        fprintf(fd,"    id    var    type    symb    ll1     ll2                     tag...\n");
	for (ll_ptr = f->head_llnd; ll_ptr; ll_ptr = ll_ptr->thread)
		write_ll_node(ll_ptr);
}


/*------------------------------------------------------*
 *		    write_symb_node			*
 *							*
 *		print out one symbol node		*
 *------------------------------------------------------*/
static void 
write_symb_node(sy_ptr)
	PTR_SYMB sy_ptr;
{
	int	n1, n2, n3, n4, n5, n6, n7, n8,n9, n10;
	char    *s1;
        char    no_name [3] = {'-','-','\0'};
	n1 = sy_ptr->id;
	n2 = sy_ptr->variant;
	n3 = FOLLOW_SYMB_POINTER_1_TO_ID(type);
	n4 = sy_ptr->attr;
	n5 = FOLLOW_SYMB_POINTER_1_TO_ID(next_symb);
	n6 = sy_ptr->scope? sy_ptr->scope->id: -1;
	s1 = sy_ptr->ident;
        if(strlen(s1)==0 || is_blank(s1)==1) s1 = no_name;
	my_fprintf_2(fd,"%4d-S %4d %4d-T %4d %4d-S %4d-B %14s ", n1, n2, n3, n4, n5, n6, s1);
 

	switch (sy_ptr->variant) {
	    case DEFAULT:
	    case TYPE_NAME:
		fprintf(fd,"%35s", " ");
		break;
	    case CONST_NAME:
		n1 = FOLLOW_SYMB_POINTER_2_TO_ID(const_value);
		fprintf(fd,"value=%17d", n1);
		break;
	    case ENUM_NAME:
	    case FIELD_NAME:
		n1 = sy_ptr->entry.field.tag;
		n2 = FOLLOW_SYMB_POINTER_2_TO_ID(field.next);
		n3 = FOLLOW_SYMB_POINTER_2_TO_ID(field.base_name);
		n4 = FOLLOW_SYMB_POINTER_2_TO_ID(field.declared_name);	 /*  NEW ADDED FOR VPC */
		n5 = FOLLOW_SYMB_POINTER_2_TO_ID(field.restricted_bit); /* NEW for VPC++ */

		my_fprintf_1(fd,"tag=%5d nxt=%5d-S base=%5d-S \n", n1, n2, n3);
		my_fprintf_5(fd,
                "                                                    dec_name=%10d-S restr=%5d-E  ", n4,n5);
		break;
	    case VARIABLE_NAME:
		n1 = sy_ptr->entry.var_decl.local;
		n2 = FOLLOW_SYMB_POINTER_2_TO_ID(var_decl.next_in);
		n3 = FOLLOW_SYMB_POINTER_2_TO_ID(var_decl.next_out);
		my_fprintf_1(fd,"local=%4d nxt_in=%4d-S nxt_out=%4d-S", n1, n2, n3);
		break;
	    case PROGRAM_NAME:
		n1 = FOLLOW_SYMB_POINTER_2_TO_ID(prog_decl.symb_list);
		n2 = FOLLOW_SYMB_POINTER_2_TO_ID(prog_decl.prog_hedr);
		my_fprintf_5(fd,"symb_lst=%11d-S prog_hedr=%5d-B", n1, n2);
		break;
            case PROCESS_NAME:
	    case PROCEDURE_NAME:
	    case FUNCTION_NAME:
		n1 = sy_ptr->entry.proc_decl.num_input;
		n2 = sy_ptr->entry.proc_decl.num_output;
		n3 = sy_ptr->entry.proc_decl.num_io;
		n4 = FOLLOW_SYMB_POINTER_2_TO_ID(proc_decl.in_list);
		n5 = FOLLOW_SYMB_POINTER_2_TO_ID(proc_decl.out_list);
		n6 = FOLLOW_SYMB_POINTER_2_TO_ID(proc_decl.symb_list);
		n7 = FOLLOW_SYMB_POINTER_2_TO_ID(proc_decl.proc_hedr);
		fprintf(fd,"n_in=%5d n_out=%5d n_io=%5d\n", n1, n2, n3);
		my_fprintf_3 (fd,
                "	                               in_l=%5d-S out_l=%5d-S sy_l=%5d-S p_hdr=%5d-B", n4, n5, n6, n7);
		break;
	    case MEMBER_FUNC:	 /*  NEW ADDED FOR VPC */
		n1 = sy_ptr->entry.member_func.num_input;
		n2 = sy_ptr->entry.member_func.num_output;
		n3 = sy_ptr->entry.member_func.num_io;
		n4 = FOLLOW_SYMB_POINTER_2_TO_ID(member_func.in_list);
		n5 = FOLLOW_SYMB_POINTER_2_TO_ID(member_func.out_list);
		n6 = FOLLOW_SYMB_POINTER_2_TO_ID(member_func.symb_list);
		n7 = FOLLOW_SYMB_POINTER_2_TO_ID(member_func.func_hedr);
		n8 = FOLLOW_SYMB_POINTER_2_TO_ID(member_func.next);
		n9 = FOLLOW_SYMB_POINTER_2_TO_ID(member_func.base_name);
		n10 = FOLLOW_SYMB_POINTER_2_TO_ID(member_func.declared_name);
		fprintf(fd,"n_in=%5d n_out=%5d n_io=%5d\n", n1, n2, n3);
		my_fprintf_3(fd,                     
                "                                     in_l=%10d-S out_l=%5d-S sy_l=%5d-S f_hdr=%5d-B \n", n4,n5,n6,n7);
		my_fprintf_1(fd,
                "	                             m_nxt=%5d-S   b_name=%5d-S   dec_name=%5d-S    ", n8, n9, n10);
		break;
/*	    case VARIANT_FIELD	:
		n1 = sy_ptr->entry.field.tag;
		n2 = FOLLOW_SYMB_POINTER_2_TO_ID(variant_field.next);
		n3 = FOLLOW_SYMB_POINTER_2_TO_ID(variant_field.base_name);
		n4 = sy_ptr->entry.variant_field.variant_list->id;
		my_fprintf_3(fd,"f.tag=%5d f.nxt=%5d-S b_name=%5d-S vl_id=%5d-E", n1, n2, n3, n4);
		break;
*/
	    default:
		fprintf(fd,"%37s", " ");
		break;
	}
	fprintf(fd,"%18s\n", tag[sy_ptr->variant]);
}


/*------------------------------------------------------*
 *		write_symb_nodes			*
 *							*
 *		dump symbol table			*
 *------------------------------------------------------*/
static void
write_symb_nodes(f)
	PTR_FILE f;
{
	register PTR_SYMB sy_ptr;
        fprintf(fd,"***SYMBOL NODES***\n\n");
	fprintf(fd,"   id   var   type  attr  next   scope  variable-name\n");
	for (sy_ptr = f->head_symb; sy_ptr; sy_ptr = sy_ptr->thread)
		write_symb_node(sy_ptr);
}


/*------------------------------------------------------*
 *		  write_type_node			*
 *							*
 *	      print out one type node			*
 *------------------------------------------------------*/
static void 
write_type_node(ty_ptr)
	PTR_TYPE ty_ptr;
{
	int	n1, n2, n3;
	int	n4, n5, n6;   /*  NEW ADDED FOR VPC */
        char buf[33];
	n1 = ty_ptr->id;
	n2 = ty_ptr->variant;
	n3 = ty_ptr->name ? ty_ptr->name->id : -1;
        n4 = (int) FOLLOW_TYPE_POINTER_TO_ID(Template.ranges);
	my_fprintf_3(fd,"%4d-T %4d %4d %4d  ", n1, n2, n3, n4);
      
	switch (ty_ptr->variant) {
	    case DEFAULT:
	    case T_INT:
	    case T_FLOAT:
	    case T_DOUBLE:
	    case T_VOID :  /*  NEW ADDED FOR VPC */
	    case T_CHAR:
	    case T_BOOL:
	    case T_STRING:
	    case T_COMPLEX:
	    case T_DCOMPLEX:
	    case T_ENUM_FIELD:
		fprintf(fd,"%46s", " ");
		break;

	    case T_SUBRANGE:
		n1 = FOLLOW_TYPE_POINTER_TO_ID(subrange.base_type);
		n2 = FOLLOW_TYPE_POINTER_TO_ID(subrange.lower);
		n3 = FOLLOW_TYPE_POINTER_TO_ID(subrange.upper);
		my_fprintf_1(fd,"base_t=%5d-T lo=%5d-E up=%5d-E", n1, n2, n3);
		break;

	    case T_ARRAY:
		n1 = ty_ptr->entry.ar_decl.num_dimensions;
		n2 = FOLLOW_TYPE_POINTER_TO_ID(ar_decl.base_type);
		n3 = FOLLOW_TYPE_POINTER_TO_ID(ar_decl.ranges);
		my_fprintf_1(fd,"dim=%5d   base_t=%5d-T   rngs=%5d-E  ", n1, n2, n3);
		break;

	    case T_LIST:
		n1 = FOLLOW_TYPE_POINTER_TO_ID(base_type);
		my_fprintf_4(fd,"base_t=%17d-T", n1);
		break;

	    case T_RECORD:
		n1 = ty_ptr->entry.re_decl.num_fields;
		n2 = FOLLOW_TYPE_POINTER_TO_ID(re_decl.first);
		my_fprintf_5(fd,"n_flds=%11d first=%5d-S", n1, n2);
		break;
	    case T_DESCRIPT:   /*  NEW ADDED FOR VPC */
		n1 = ty_ptr->entry.descriptive.signed_flag ;
		n2 = ty_ptr->entry.descriptive.long_short_flag;
		n3 = ty_ptr->entry.descriptive.mod_flag ;
		n4 = ty_ptr->entry.descriptive.storage_flag ;
		n5 = ty_ptr->entry.descriptive.access_flag ;
		n6 = ty_ptr->entry.descriptive.base_type? ty_ptr->entry.descriptive.base_type->id:-1 ;
		     
		fprintf(fd,"sgned=%5d mod_flg=%5d",n1,n3);
                print_ls_flg(n2);
		fprintf(fd,"        sto_flg=%10d",n4);
                print_accs_flg(n5);
                my_fprintf_4(fd,"  base_t=%5d-T",n6);  
		break;
	    case T_POINTER :   /*  NEW ADDED FOR VPC */
		n1 = FOLLOW_TYPE_POINTER_TO_ID(Template.base_type);
	  	n2 = ty_ptr->entry.Template.dummy1 ; /* indirect level */
                n3 = ty_ptr->entry.Template.dummy5;
                my_fprintf_4(fd,"base_t=%5d-T ", n1); 		
                fprintf(fd,"ind_lev=%3d  ", n2);
                print_ls_flg(n3);
                fprintf(fd,"%68s"," ");
		break;

	    case T_REFERENCE :   /*  added by BW */
		n1 = FOLLOW_TYPE_POINTER_TO_ID(Template.base_type);
	  	n2 = ty_ptr->entry.Template.dummy1 ; /* indirect level */
                n3 = ty_ptr->entry.Template.dummy5;
                my_fprintf_4(fd,"base_t=%5d-T ", n1); 		
                fprintf(fd,"ind_lev=%3d  ", n2);
                print_ls_flg(n3);
                fprintf(fd,"%68s"," ");
		break;
		
	    case T_FUNCTION:   /*  NEW ADDED FOR VPC */
		n1 = FOLLOW_TYPE_POINTER_TO_ID(Template.base_type);
		my_fprintf_4(fd,"base_t=%17d-T", n1);
		break;

	    case T_DERIVED_TYPE :   /*	NEW ADDED FOR VPC */
		n1 = FOLLOW_TYPE_POINTER_TO_ID(derived_type.symbol);
		my_fprintf_4(fd,"der_typ=%7d-S                              ", n1);
		break;
            case T_MEMBER_POINTER:
                n1 = FOLLOW_TYPE_POINTER_TO_ID(col_decl.collection_name);
                n2 = FOLLOW_TYPE_POINTER_TO_ID(col_decl.base_type);
                my_fprintf_5(fd,"class name= %5d-S value type = %5d-T", n1, n2);
                break;
            case T_DERIVED_COLLECTION:
		n1 = FOLLOW_TYPE_POINTER_TO_ID(col_decl.collection_name);
		n2 = FOLLOW_TYPE_POINTER_TO_ID(col_decl.base_type);
		my_fprintf_5(fd,"base class= %5d-S arg type = %5d-T", n1, n2);
                break;
	    case T_ENUM:
	    case T_UNION:   /*	NEW ADDED FOR VPC */
	    case T_STRUCT:  /*	NEW ADDED FOR VPC */
	    case T_CLASS :  /*	NEW ADDED FOR VPC */
	    case T_DERIVED_CLASS :   /*  NEW ADDED FOR VPC */
		n1 = ty_ptr->entry.derived_class.num_fields;
		n2 = FOLLOW_TYPE_POINTER_TO_ID(derived_class.first);
		n3 = FOLLOW_TYPE_POINTER_TO_ID(derived_class.original_class);
		my_fprintf_1(fd,"num_flds=%5d first=%5d-S parent=%5d-B    ", n1, n2, n3);
		break;
		
	    default:
                fprintf(fd, "%46s", " ");
		break;
	}
	fprintf(fd,"%21s\n", tag[ty_ptr->variant]);
}

/*------------------------------------------------------*
 *		    write_type_nodes			*
 *------------------------------------------------------*/
static void
write_type_nodes(f)
	PTR_FILE f;
{
	PTR_TYPE ty_ptr;
        fprintf(fd,"***TYPE NODES***\n\n");
	fprintf(fd,"   id   var name length\n");
	for (ty_ptr = f->head_type; ty_ptr; ty_ptr = ty_ptr->thread)
		write_type_node(ty_ptr);
        fprintf(fd, "\n  bits set:   0 syn/protected,  1 shared/public,  2 private,  3 future,  4 virtual,\n");
        fprintf(fd, "                5 inline,  6 unsigned,  7 signed,  8 short,  9 long,  10 volatile,\n");
        fprintf(fd, "                11 const,  12 typedef,  13 extern,  14 friend,  15 static,  16 register,\n");
        fprintf(fd, "                17 auto,  18 global,  19 Sync,  20 atomic,  21 __private, 22 restrict\n"); 
}


/*------------------------------------------------------*
 *		    write_label_node			*
 *------------------------------------------------------*/
static void 
write_label_node(lb_ptr)
	PTR_LABEL lb_ptr;
{
	int	n1, n2, n4, n5;
	long	n3;

	n1 = lb_ptr->id;
	n2 = (int)lb_ptr->stateno;
	n3 = lb_ptr->labtype;
	n4 = lb_ptr->statbody ? lb_ptr->statbody->id : -1;
	n5 = lb_ptr->label_name ? lb_ptr->label_name->id : -1 ;
	my_fprintf_6(fd,"%5d-L %5d %5d %5d-B %5d-S \n", n1, n2, n3, n4,n5);
}


/*------------------------------------------------------*
 *		    write_label_nodes			*
 *------------------------------------------------------*/
static void 
write_label_nodes(f)
	PTR_FILE f;
{
	PTR_LABEL lb_ptr;
        fprintf(fd,"***LABEL NODES***\n\n");

	for (lb_ptr = f->head_lab; lb_ptr; lb_ptr = lb_ptr->next)
		write_label_node(lb_ptr);
}


/*------------------------------------------------------*
 *		  write_comment_node			*
 *							*
 *	      print out one comment node		*
 *------------------------------------------------------*/
static void 
write_comment_node(cm_ptr)
	PTR_CMNT cm_ptr;
{
	int	n1, n2, n3;
	char	*s;

	n1 = cm_ptr->id;
	n2 = cm_ptr->type;
	n3 = cm_ptr->next ? cm_ptr->next->id : -1;
	s  = cm_ptr->string;

	my_fprintf_1(fd,"%5d-C %5d %5d-C \n", n1, n2, n3);
	fprintf(fd,"      %s\n", s);
}


/*------------------------------------------------------*
 *		    write_comment_nodes 		*
 *------------------------------------------------------*/
static void
write_comment_nodes(f)
	PTR_FILE f;
{
	PTR_CMNT cm_ptr;
        fprintf(fd,"***COMMENT NODES***\n\n");

	for (cm_ptr = f->head_cmnt; cm_ptr; cm_ptr = cm_ptr->thread)
		write_comment_node(cm_ptr);
}


/*------------------------------------------------------*
 *		    write_filename_nodes		*
 *------------------------------------------------------*/
static void
write_filename_nodes(f)
	PTR_FILE f;
{
	PTR_FNAME filep;
        fprintf(fd,"***FILENAME NODES***\n\n");

	for (filep = f->head_file; filep; filep = filep->next)
		fprintf(fd,"%5d-F %s\n", filep->id, filep->name);
}


/*------------------------------------------------------*
 *		   write_dep_node			*
 *							*
 *	    print out one dependence node		*
 *------------------------------------------------------*/
static void 
write_dep_node(dep)
	PTR_DEP dep;
{
	register int j;
	int	n1, n2, n3, n4, n5, n6, n7, n8, n9, n10, n11,n12;

	n1 = dep->id;
	n2 = dep->type;
	n3 = FOLLOW_DEP_TO_ID(symbol);
	n4 = FOLLOW_DEP_TO_ID(from.stmt);
	n5 = FOLLOW_DEP_TO_ID(from.refer);
	n6 = FOLLOW_DEP_TO_ID(to.stmt);
	n7 = FOLLOW_DEP_TO_ID(to.refer);
	n8 = FOLLOW_DEP_TO_ID(from_fwd);
	n9 = FOLLOW_DEP_TO_ID(from_back);
	n10 = FOLLOW_DEP_TO_ID(to_fwd);
	n11 = FOLLOW_DEP_TO_ID(to_back);

        depden_llnd[depden_llnd_sum][1] = n5;
        depden_llnd[depden_llnd_sum][2] = n7;


	fprintf(fd,"%4d %4d %4d %4d %4d %4d %4d %4d %4d %4d %4d",
	       n1, n2, n3, n4, n5, n6, n7, n8, n9, n10, n11);

        putw(n2,fptm1);
        putw(n3,fptm1);
        putw(n4,fptm1);
        putw(n6,fptm1);

	for (j = 0; j < MAX_DEP; j++)
              {
                n12 =(int) dep->direct[j];
                fprintf(fd," %2d",n12);
      /*        fprintf(fd," %2d", (int) dep->direct[j]); */
                putw(n12,fptm2);
              }
	fprintf(fd,"\n");

}


static
char   *sdeptype[] = {
	 "Flow dependence",
	 "Anti dependence",
	 "Output dependence",
	 "	  "
};

/*------------------------------------------------------*
 *		    write_one_dep			*
 *							*
 *	    print out one dependence relation		*
 *------------------------------------------------------*/
static void 
write_one_dep(dep)
	PTR_DEP  dep;
{
	int i;

	fprintf(fd,"  %-18s,", sdeptype[dep->type]);
	fprintf(fd," symb = %-5s,", dep->symbol ? dep->symbol->ident : " ");
	fprintf(fd," from node %2d(%2d) to node %2d(%2d), dir vector = ",
	   dep->from.stmt->id,dep->from.refer->id,dep->to.stmt->id,dep->to.refer->id);
	for (i = 0; i <= MAX_LP_DEPTH; i++)
		fprintf(fd,"  %d", dep->direct[i]);
	fprintf(fd,".\n");
}


/*--------------------------------------------------------*
 *		    write_dep_comments			  *
 *							  *
 * write out the dependence relations in readable formats *
 *--------------------------------------------------------*/
static void 
write_dep_comments(f)
	PTR_FILE	f;
{
	register PTR_DEP dep;

	if (!f->num_dep)
		return;
	fprintf(fd,"\n\n");
	fprintf(fd," The following %d dependence relations are found:\n",f->num_dep);
	for (dep = f->head_dep; dep && dep->id != -1; dep = dep->thread)
		write_one_dep(dep);
}


/*------------------------------------------------------*
 *		    write_dep_nodes			*
 *------------------------------------------------------*/
static void 
write_dep_nodes(f)
	PTR_FILE	f;
{
	register PTR_DEP dep;

	if (!f->num_dep)
		return;
        fprintf(fd,"***DEPENDENCE NODES***\n\n");

	fprintf(fd,"  id type symb f-bf f-ll t-bf t-ll ffwd fbak tfwd tbak d-vec\n");
        depden_llnd_sum = 0;
	for (dep = f->head_dep; dep && dep->id != -1; dep = dep->thread)
            {
		write_dep_node(dep);
                depden_llnd_sum++;
            }
}

write_depden_llnd(proj_name)
char     * proj_name;
{
        char     * string1,* string2;
        int      i,ei;
        FILE     * fptm3;

        string1 = malloc(50);
        string2 = malloc(50);
/***
        if ((fptm3 = fopen ("vdep.sig3", "w")) == NULL)
                        return -1;

        SiOpenProject(proj_name,proj_name);

        for (i=0;i<=depden_llnd_sum-1;i++)
           {
             SiSUnparseEList(string1,SiUnparseExpr(depden_llnd[i][1]));
             SiSUnparseEList(string2,SiUnparseExpr(depden_llnd[i][2]));
  
             fprintf(fptm3,"%-20s --> %-20s\n",string1,string2);

           }

        fclose(fptm3);
        free(string1);
        free(string2);
        SiCloseProject();
***/
}

int dump_nodes(f, name)
	PTR_FILE f;
	char *name;
{
        char     *proj_name;
        int       len,i;

#include "tag.h"		/* associate string with variant tags */

          /* vdep.sig  is data file for  visual  dumpdep  */

        if ((fptm = fopen ("vdep.sig","wb"))==NULL)
          {
           printf("cannot  open  this  file\n");
           exit(0);
          }

        if ((fptm1 = fopen ("vdep.sig1","wb"))==NULL)
          {
           printf("cannot  open  this  file\n");
           exit(0);
          }

        if ((fptm2 = fopen ("vdep.sig2","wb"))==NULL)
          {
           printf("cannot  open  this  file\n");
           exit(0);
          }

	if (*name) {		/* filename specified? */
		if ((fd = fopen (name, "w")) == NULL)
			return -1;
	} else
		fd = stdout;

	fprintf(fd,"Source is \"%s\"\n", f->head_file->name);

        len = strlen(f->head_file->name)-2;
        proj_name = malloc(len+10);
        for(i=0;i<len;i++)
           proj_name[i]=f->head_file->name[i];

        proj_name[len]='\0';
        sprintf(proj_name,"%s.proj",proj_name);
        printf("-------%s;;;;%s\n",proj_name,f->head_file->name);
	
	write_sizes(f); 	fprintf(fd,"\n");
	write_bif_nodes(f);	fprintf(fd,"\n");
	write_ll_nodes(f);	fprintf(fd,"\n");
	write_symb_nodes(f);	fprintf(fd,"\n");
	write_type_nodes(f);	fprintf(fd,"\n");
	write_label_nodes(f);	fprintf(fd,"\n");
	write_comment_nodes(f); fprintf(fd,"\n");
	write_filename_nodes(f);fprintf(fd,"\n");
	write_dep_nodes(f);
	write_dep_comments(f);
        write_depden_llnd(proj_name);

	if (fd != stderr)
		return fclose(fd);

        fclose(fptm);
        fclose(fptm1);
        fclose(fptm2);
        free(proj_name);
	return 0;
}
